DROP TABLE joe_quality CASCADE CONSTRAINTS;
DROP TABLE joe_staff CASCADE CONSTRAINTS;
DROP TABLE joe_requirement CASCADE CONSTRAINTS;
DROP TABLE joe_game CASCADE CONSTRAINTS;
DROP TABLE joe_company CASCADE CONSTRAINTS;
DROP TABLE joe_supplier CASCADE CONSTRAINTS;
DROP TABLE joe_user CASCADE CONSTRAINTS;
DROP TABLE joe_buy CASCADE CONSTRAINTS;
DROP SEQUENCE joe_game_id;
DROP SEQUENCE joe_staff_id;
DROP SEQUENCE joe_company_id;

CREATE SEQUENCE joe_game_id
INCREMENT BY 1
START WITH 1
MAXVALUE 999999999999
NOCACHE
NOCYCLE
;

CREATE SEQUENCE joe_staff_id
INCREMENT BY 1
START WITH 1
MAXVALUE 999999999999
NOCACHE
NOCYCLE
;

CREATE SEQUENCE joe_company_id
INCREMENT BY 1
START WITH 1
MAXVALUE 999999999999
NOCACHE
NOCYCLE
;

CREATE TABLE joe_company
(
companyid NUMBER(12),
name CHAR(50) NOT NULL,
place CHAR(255),
website CHAR(255),
manager CHAR(50),
email CHAR(255),
birthdate DATE,
PRIMARY KEY (companyid)
)
;

CREATE TABLE joe_supplier
(
supplyid NUMBER(12),
name CHAR(50) NOT NULL,
place CHAR(255),
website CHAR(255),
manager CHAR(50),
email CHAR(255),
birthdate DATE,
PRIMARY KEY (supplyid)
)
;

CREATE TABLE joe_game
(
gameid NUMBER(12),
companyid NUMBER(12),
supplyid NUMBER(12),
name CHAR(50) NOT NULL,
genre CHAR(50),
price NUMBER(20),
birthdate DATE,
howmanysold NUMBER(20),
PRIMARY KEY (gameid),
FOREIGN KEY (companyid) REFERENCES joe_company ON DELETE CASCADE,
FOREIGN KEY (supplyid) REFERENCES joe_supplier ON DELETE CASCADE
)
;

CREATE TABLE joe_staff
(
staffid NUMBER(12),
gameid NUMBER(12),
name CHAR(50) NOT NULL,
email CHAR(255),
dowhat CHAR(50) NOT NULL,
PRIMARY KEY (staffid),
FOREIGN KEY (gameid) REFERENCES joe_game ON DELETE CASCADE
)
;

CREATE TABLE joe_requirement
(
gameid NUMBER(12),
cpu CHAR(50),
hdd NUMBER(20),
ram NUMBER(20),
PRIMARY KEY (gameid),
FOREIGN KEY (gameid) REFERENCES joe_game ON DELETE CASCADE
)
;

CREATE TABLE joe_quality
(
gameid NUMBER(12),
graphic NUMBER(1),
sound NUMBER(1),
scenario NUMBER(1),
PRIMARY KEY (gameid),
FOREIGN KEY (gameid) REFERENCES joe_game ON DELETE CASCADE
)
;

CREATE TABLE joe_user
(
password CHAR(10),
name CHAR(50),
email CHAR(255),
id CHAR(10),
spent NUMBER(20),
PRIMARY KEY (id)
)
;

CREATE TABLE joe_buy
(
id CHAR(10),
gameid NUMBER(12),
FOREIGN KEY (id) REFERENCES joe_user ON DELETE CASCADE,
FOREIGN KEY (gameid) REFERENCES joe_game ON DELETE CASCADE
)
;
