
import java.io.*;
import java.lang.*;
import java.net.*;

/**
* Html Parser , make parse tree for html syntax
*
* @author	Joon-Myung Kang
* @version	0.5
* @since	1999/05/22
*/

public class Parser
{
	String genre;
	String site;
	String query;
	DBQuery dbQuery;

	/**
	* Parse a web page.
	*
	* @param addr the web page address which will be parsed
	* @return none
	*/
	public Parser(String addr)
	{
		genre=null;
		site=null;
		URL url=null;
		dbQuery=new DBQuery();

		try
		{
			url=new URL(addr);
		}
		catch(MalformedURLException e)
		{
			e.printStackTrace();
		}

		Tagtree t=new Tagtree(url);
		Node n=t.getRoot();

		site=addr;

		if(addr.equalsIgnoreCase("http://www.cdromshop.com/cdshop/w95/cat22.html"))
		{
			query = "DELETE FROM joec_game where site = "+"'"+site+"'";
			dbQuery.update(query);
			parseCDROMSHOP(n);
		}
		else if(addr.indexOf("http://www.garlic.com/~dennisa/games")!=-1)
		{
			query = "DELETE FROM joec_game where site = "+"'"+site+"'";
			dbQuery.update(query);
			parseGARLIC(n);
		}
		else if(addr.indexOf("http://www.pcsoftwaregames.com/games2.htm")!=-1)
		{
			query = "DELETE FROM joec_game where site = "+"'"+site+"'";
			dbQuery.update(query);
			parsePCSOFTWAREGAMES(n);
		}
		else if(addr.indexOf("http://www.tronixweb.com/pccdp.html")!=-1)
		{
			query = "DELETE FROM joec_game where site = "+"'"+site+"'";
			dbQuery.update(query);
			parseTRONIXWEB(n);
		}
		else if(addr.indexOf("http://www.lazybone.com/Templates/frmTemplateL.asp?SubFolderID=20&SearchYN=N")!=-1)
		{
			query = "DELETE FROM joec_game where site = "+"'"+site+"'";
			dbQuery.update(query);
			genre="action";
			parseLAZYBONE(n);
		}
		else if(addr.indexOf("http://www.lazybone.com/Templates/frmTemplateL.asp?SubFolderID=21&SearchYN=N")!=-1)
		{
			query = "DELETE FROM joec_game where site = "+"'"+site+"'";
			dbQuery.update(query);
			genre="adventure";
			parseLAZYBONE(n);
		}
		else if(addr.indexOf("http://www.lazybone.com/Templates/frmTemplateL.asp?SubFolderID=33&SearchYN=N")!=-1)
		{
			query = "DELETE FROM joec_game where site = "+"'"+site+"'";
			dbQuery.update(query);
			genre="simulation";
			parseLAZYBONE(n);
		}
		else if(addr.indexOf("http://www.lazybone.com/Templates/frmTemplateL.asp?SubFolderID=24&SearchYN=N")!=-1)
		{
			query = "DELETE FROM joec_game where site = "+"'"+site+"'";
			dbQuery.update(query);
			genre="roleplaying";
			parseLAZYBONE(n);
		}
		else if(addr.indexOf("http://www.lazybone.com/Templates/frmTemplateL.asp?SubFolderID=23&SearchYN=N")!=-1)
		{
			query = "DELETE FROM joec_game where site = "+"'"+site+"'";
			dbQuery.update(query);
			genre="simulation";
			parseLAZYBONE(n);	
		}
		else if(addr.indexOf("http://www.lazybone.com/Templates/frmTemplateL.asp?SubFolderID=27&SearchYN=N")!=-1)
		{
			query = "DELETE FROM joec_game where site = "+"'"+site+"'";
			dbQuery.update(query);
			genre="sports";
			parseLAZYBONE(n);
		}
/*		else if(addr.indexOf("http://www.lazybone.com/Templates/frmTemplateL.asp?SubFolderID=25&SearchYN=N")!=-1)
		{
			genre="simulation";
			parseLAZYBONE(n);
		}*/
		else
			n.printTree(0);
	}

	/**
	* Parse http://www.cdromshop.com/cdshop/w95/cat22.html.
	*
	* @param node root node
	* @return none
	*/
	public void parseCDROMSHOP(Node node)
	{
		Node parseNode=node;
		String name=null;
		String birth=null;
		String price=null;
		String company=null;

		try
		{
			if(parseNode.getLabel().equalsIgnoreCase("h4"))
			{
				if(parseNode.getChildAt(0).getLabel().equalsIgnoreCase("no_attribute")&&parseNode.getChildAt(1).getLabel().equalsIgnoreCase("form"))
				{
					parseNode=parseNode.getChildAt(1);
					if(parseNode.getChildAt(0).getLabel().equalsIgnoreCase("attribute")&&parseNode.getChildAt(1).getLabel().equalsIgnoreCase("input")&&parseNode.getChildAt(2).getLabel().equalsIgnoreCase("input"))
					{
						name=null;
						birth=null;
						price=null;
						company=null;

						String parseName;
						String parseBirth;
						String parsePrice;
						String parseCompany;

						int parseStart;
						int parseEnd;

						parseName=parseNode.getChildAt(3).getLabel();
						parseEnd=parseName.indexOf("_");
						if(parseEnd!=-1)
							name=parseName.substring(0,parseEnd).trim();

						parsePrice=parseNode.getChildAt(5).getLabel();
						parseStart=parsePrice.indexOf("Price: US$");
						parseEnd=parsePrice.indexOf("RELEASE DATE:");
						if(parseStart!=-1&&parseEnd!=-1)
							price=parsePrice.substring(parseStart+10,parseEnd).trim();
						else if(parseStart!=-1)
							price=parsePrice.substring(parseStart+10).trim();

						parseCompany=parseNode.getChildAt(5).getLabel();
						parseStart=parseCompany.lastIndexOf("_");
						if(parseStart==-1)
						{
							parseStart=parseCompany.lastIndexOf("By:");
							parseStart+=3;
						}
						else
						{
							parseStart++;
						}
						parseEnd=parseCompany.indexOf("Price:");
						if(parseStart!=-1&&parseEnd!=-1)
							company=parseCompany.substring(parseStart,parseEnd).trim();

						parsePrice=parseNode.getChildAt(5).getLabel();
						parseStart=parsePrice.indexOf("RELEASE DATE:");
						if(parseStart!=-1)
							birth=parsePrice.substring(parseStart+13).trim();

						parseBirth=parseNode.getChildAt(7).getLabel();
						parseStart=parseBirth.indexOf("RELEASE DATE:");
						if(parseStart!=-1)
							birth=parseBirth.substring(parseStart+13).trim();
						parseStart=birth.indexOf(",");
						if(parseStart!=-1)
							birth=birth.substring(parseStart+2) ;
					}
				}
			}
		}
		catch(ArrayIndexOutOfBoundsException e)
		{
		}
		catch(StringIndexOutOfBoundsException e)
		{
		}

		if(name!=null&&price!=null&&company!=null)
		{
			String query;
			query = "INSERT INTO joec_game ( id, name, genre, birth, price, site, company ) VALUES ( joec_game_id.NEXTVAL," + "'" + name + "'" + "," + "''" + "," + "TO_DATE(" + birth + ",'YYYY')" + "," + price + "," + "'" + site + "'" + "," + "'" + company + "'" + ")";
			dbQuery.update(query);
		}

		for(int i=0;i<node.childSize();i++)
		{
			parseCDROMSHOP(node.getChildAt(i)) ;
		}
	}

	public void parseGARLIC(Node node)
	{
		String name=null;
		String price=null;
		Node parseNode=node;

		try
		{
			if(parseNode.getLabel().equalsIgnoreCase("tr"))
			{
				if(parseNode.getChildAt(0).getLabel().equalsIgnoreCase("no_attribute")&&parseNode.getChildAt(1).getLabel().equalsIgnoreCase("td")&&(parseNode.getChildAt(1).getChildAt(0).getChildAt(1).getChildAt(0).getLabel().equalsIgnoreCase("217")||parseNode.getChildAt(1).getChildAt(0).getChildAt(0).getChildAt(0).getLabel().equalsIgnoreCase("217")))
				{
					String parseName=null;
					String parsePrice=null;
					int parseStart;
					int parseEnd;

					parseName=parseNode.getChildAt(3).getChildAt(1).getChildAt(1).getChildAt(1).getLabel();
					if(parseNode.getChildAt(4).getChildAt(1).getLabel().equalsIgnoreCase("p"))
						parsePrice=parseNode.getChildAt(4).getChildAt(2).getChildAt(1).getChildAt(1).getLabel();
					else
						parsePrice=parseNode.getChildAt(4).getChildAt(1).getChildAt(1).getChildAt(1).getLabel();

					if(parseName.equalsIgnoreCase("span")||parseName.equalsIgnoreCase("strong")||parseName.equalsIgnoreCase("font"))
						parseName=parseNode.getChildAt(3).getChildAt(1).getChildAt(1).getChildAt(1).getChildAt(1).getLabel();

					if(parseName.equalsIgnoreCase("span")||parseName.equalsIgnoreCase("strong")||parseName.equalsIgnoreCase("font"))
						parseName=parseNode.getChildAt(3).getChildAt(1).getChildAt(1).getChildAt(1).getChildAt(1).getChildAt(1).getLabel();

					name=parseName.trim();

					parseEnd=parseName.indexOf("(");
					if(parseEnd!=-1)
						name=parseName=parseName.substring(0,parseEnd).trim();

					parseEnd=parseName.lastIndexOf("BY");
					if(parseEnd!=-1)
						name=parseName=parseName.substring(0,parseEnd).trim();

					price=parsePrice.substring(1).trim();
				}
			}
		}
		catch(ArrayIndexOutOfBoundsException e)
		{
		}
		catch(StringIndexOutOfBoundsException e)
		{
		}

		if(name!=null&&price!=null)
		{
			query = "INSERT INTO joec_game ( id, name, genre, birth, price, site, company ) VALUES ( joec_game_id.NEXTVAL," + "'" + name + "'" + "," + "''" + "," + "''" + "," + price + "," + "'" + site + "'" + "," + "''" + ")";
			dbQuery.update(query);
		}

		for(int i=0;i<node.childSize();i++)
		{
			parseGARLIC(node.getChildAt(i)) ;
		}
	}

	public void parsePCSOFTWAREGAMES(Node node)
	{
		Node parseNode=node;

		String name=null;
		String price=null;

		try
		{
			if(parseNode.getLabel().equalsIgnoreCase("Simulations"))
				genre="simulation";
			if(parseNode.getLabel().equalsIgnoreCase("Action"))
				genre="action";
			if(parseNode.getLabel().equalsIgnoreCase("Strategy"))
				genre="simulation";
                        if(parseNode.getLabel().equalsIgnoreCase("Sports"))
				genre="sports";
			if(parseNode.getLabel().equalsIgnoreCase("War Games"))
				genre="simulation";
			if(parseNode.getLabel().equalsIgnoreCase("#Close Out"))
				genre=null;
			
			if(parseNode.getLabel().equalsIgnoreCase("tr"))
			{
				String parseGenre=null;
				
				//  ̸  ãƳ.
				if(parseNode.getChildAt(0).getLabel().equalsIgnoreCase("no_attribute") && !parseNode.getChildAt(1).getLabel().equalsIgnoreCase("font"))
				{
					String parseName=null;
					String parsePrice=null;
					Node nodeName=null;
					Node nodePrice=null;

					nodeName=parseNode.getChildAt(1).getChildAt(1);
					if(nodeName.getLabel().equalsIgnoreCase("A"))
					{
						nodeName=nodeName.getChildAt(1);
					}

					nodePrice=parseNode.getChildAt(2).getChildAt(1).getChildAt(1);
				
					parseName=nodeName.getLabel();
					parsePrice=nodePrice.getLabel();
					parseGenre=genre;

					name=parseName;
					price=parsePrice;
				}
			}
		}

		catch(ArrayIndexOutOfBoundsException e)
		{
		}
		catch(StringIndexOutOfBoundsException e)
		{
		}
		if(name!=null && price!=null && price.charAt(0)=='$')
		{
			query = "INSERT INTO joec_game ( id, name, genre, birth, price, site, company ) VALUES ( joec_game_id.NEXTVAL," + "'" + name + "'" + "," + "'" + genre + "'" + "," + "''" + "," + price.substring(1) + "," + "'" + site + "'" + "," + "''" + ")";
			dbQuery.update(query);
		}

		for(int i=0; i<node.childSize(); i++)
		{
			parsePCSOFTWAREGAMES(node.getChildAt(i));
		}
	}
	public void parseTRONIXWEB(Node node)
	{
		Node parseNode=node;

		String name=null;
		String price=null;
		
		try
		{
			if(parseNode.getLabel().equalsIgnoreCase("tr"))
			{
				Node nodeName;
				Node nodePrice;

				nodeName=parseNode.getChildAt(1).getChildAt(1).getChildAt(1).getChildAt(1);
				if(nodeName.getLabel().equalsIgnoreCase("A"))
				{
					nodeName=nodeName.getChildAt(1);
				}
				nodePrice=parseNode.getChildAt(2).getChildAt(1).getChildAt(1).getChildAt(1);

				name=nodeName.getLabel();
				price=nodePrice.getLabel();
			}
		}

		catch(ArrayIndexOutOfBoundsException e)
		{
		}

		catch(StringIndexOutOfBoundsException e)
		{
		}
	
		if(name!=null && price!=null && price.charAt(0)=='$')
		{
			query = "INSERT INTO joec_game ( id, name, genre, birth, price, site, company ) VALUES ( joec_game_id.NEXTVAL," + "'" + name + "'" + "," + "''" + "," + "''" + "," + price.substring(1) + "," + "'" + site + "'" + "," + "''" + ")";
			dbQuery.update(query);
		}

		for(int i=0; i<node.childSize(); i++)
		{
			parseTRONIXWEB(node.getChildAt(i));
		}
	}

	public void parseLAZYBONE(Node node)
	{
		Node parseNode=node;
		String name[]=new String[3];
		String price[]=new String[3];

		try
		{
			if(parseNode.getLabel().equalsIgnoreCase("FORM"))
			{
				Node nodeNameParent;
				Node nodePriceParent;

				nodeNameParent=parseNode.getChildAt(1).getChildAt(2);
				nodePriceParent=parseNode.getChildAt(1).getChildAt(3);

				for(int i=1; i<4; i++)
				{
					name[i-1]=nodeNameParent.getChildAt(i).getChildAt(3).getLabel();
					price[i-1]=nodePriceParent.getChildAt(i).getChildAt(nodePriceParent.getChildAt(i).childSize()-1).getLabel();
				}
			}
		}

		catch(ArrayIndexOutOfBoundsException e)
		{
		}

		catch(StringIndexOutOfBoundsException e)
		{
		}

		for(int i=0; i<3; i++)
		{
			int index;
			if(name[i]==null || price[i]==null)
			{
				i++;
				continue;
			}
			index=price[i].indexOf('$');
			if(index<0)
			{
				i++;
				continue;
			}
			String sname=name[i];
			String sprice=price[i].substring(index+1);

			query = "INSERT INTO joec_game ( id, name, genre, birth, price, site, company ) VALUES ( joec_game_id.NEXTVAL," + "'" + sname + "'" + "," + "'" + genre + "'" + "," + "''" + "," + sprice + "," + "'" + site + "'" + "," + "''" + ")";
			dbQuery.update(query);
		}

		for(int i=0; i<node.childSize(); i++)
		{
			parseLAZYBONE(node.getChildAt(i));
		}
	}

	/**
	* Start parser.
	*
	* @param argv[] argument url
	* @return none
	*/
	public static void main(String argv[])
	{
		new Parser(argv[0]);
	}

}

