
import java.lang.*;
import java.net.*;
import java.io.*;

/**
* connect to URL.
* and then convert url to string
*
* @author Joon-Myung Kang
* @version 1.0
* @since 1999/5/22
*/
public class RemoteDocument{

	/**
	* target url
	*/
	URL target;
	/**
	* string document
	*/
	String doc;


	/**
	* constructor.
	* 
	* @param st is url
	* @return none
	*/
	RemoteDocument(String st){
	//st is URL
		try{
			target = new URL(st);
		} catch ( MalformedURLException e ) {
			e.printStackTrace();
		}

		downloadData( target );
	}

	/**
	* constructor.
	*
	* @param u is url
	* @return none
	*/
	RemoteDocument(URL u ){
		downloadData( u );
	}

	/**
	* download data from url
	*
	* @param st is url
	* @return none
	*/
	void downloadData(URL st){

		target = st;

		try{ 
			URLConnection con = target.openConnection(); 
			
			if( con.getDoInput() == true){

				InputStream iStream = con.getInputStream();

				DataInputStream data = new DataInputStream( iStream );

				String line;
				StringBuffer sb = new StringBuffer();
				int LineNumber = 1;

				while(( line = data.readLine() ) != null ){
					sb.append( line );
				}
				doc = new String( sb );
				data.close();
			}
		} catch( IOException e ){
			e.printStackTrace();
		}

	}

	/** 
	* get doc string
	*
	* @param none
	* @return doc string
	*/
	String getDocString(){ return doc;}
}

// end of file
