//package libero.UI;


import java.awt.*;
import java.awt.event.*;

public class TreeUI extends Frame
					implements	ActionListener
{


	private Button	loadButton;
	private Button	exitButton;
	private	Button	searchButton;
	private treeCanvas drawA; 
	private	Panel		basePanel;
	private	BorderLayout	layoutManager;
	private	Panel		buttonPanel;
	private	ScrollPane	scrollPanel;
	private	Panel		searchPanel;
	private	TextField	queryInput;


	private	Node	root;

	public TreeUI( MTree t){

		root = t.getRoot();

		setSize(800,800);

		drawA = new treeCanvas(t );

		layoutComponents(); 

		show();
//		enableEvents( AWTEvent.MOUSE_EVENT_MASK );

	}

	private void layoutComponents(){

		basePanel = new Panel();
		//layoutManager = new GridLayout(3,1,10,10);
		layoutManager = new BorderLayout(10,10);
		basePanel.setLayout(layoutManager);
		//basePanel.setSize(800,900);

			buttonPanel = new Panel();

				loadButton = new Button("load");
				loadButton.addActionListener(this);
				buttonPanel.add(loadButton);

				exitButton = new Button("exit");
				exitButton.addActionListener(this);
				buttonPanel.add(exitButton);
			basePanel.add(buttonPanel, BorderLayout.NORTH);
			//basePanel.add(buttonPanel);

			scrollPanel = new ScrollPane();
				scrollPanel.add(drawA);
			scrollPanel.setSize(new Dimension(800,800));

			basePanel.add(scrollPanel, BorderLayout.CENTER);
			//basePanel.add(scrollPanel);

			searchPanel = new Panel();

				queryInput = new TextField("input query expression",30);
				searchPanel.add(queryInput);

				searchButton = new Button("search");
				searchButton.addActionListener(this);
				searchPanel.add(searchButton);

			basePanel.add(searchPanel, BorderLayout.SOUTH);
			//basePanel.add(searchPanel);

		add(basePanel);
	}

	public	void	actionPerformed(ActionEvent event)
	{
		if( event.getSource() == loadButton)
		{
			MessageBox	errorMessage = new MessageBox("Not implemented");
			errorMessage.pack();
			errorMessage.show();
		}
		else if( event.getSource() == exitButton)
		{
			dispose();
			System.exit(0);
		}
		else if( event.getSource() == searchButton)
		{

			Node	resultNode = (root.getChildAt(0)).query(queryInput.getText(),"");
			// get guery string

// add more code here
// add more code here
// add more code here
			resultNode.changeLabel(queryInput.getText());

			ResultTree	result = new ResultTree(new MTree(resultNode));
			result.pack();
			result.show();
		}
	}
}

