import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;


public class ListGame extends HttpServlet
{
	DBQuery dbQuery;

	public void init(ServletConfig config) throws ServletException
	{
		super.init(config);
		dbQuery=new DBQuery();
	}

	public void destroy()
	{
		dbQuery.close();
		dbQuery=null;
	}

	public void doGet(HttpServletRequest request,HttpServletResponse response) 
	{
        	try
		{
			PrintWriter out;
			response.setContentType("text/html");

			out = response.getWriter();

			if(CookieUser.getUser(request)==null)
				response.sendRedirect(JoeEnv.LoginLocation);

			String qcompanyname=request.getParameter("company");
			String qgamename=request.getParameter("name");
			String qgameid=request.getParameter("id");
			String qgenre=request.getParameter("genre");
			String qprice=request.getParameter("price");
			String qhowmanysold=request.getParameter("site");
			String qpriceob=request.getParameter("priceob");
			String qcase=request.getParameter("case");
			String qyear=request.getParameter("year");

			String companynameQuery="";
			String supplyidQuery="";
			String gamenameQuery="";
			String gameidQuery="";
			String genreQuery="";
			String priceQuery="";
			String yearQuery="";

			boolean iscase=false;

			if(qcase!=null&&qcase.equals("on"))
				iscase=true;
			else
				iscase=false;

			if(qcompanyname!=null&&qcompanyname.length()!=0)
			{
				if(iscase)
					companynameQuery=" AND company LIKE '%"+qcompanyname+"%'";
				else
					companynameQuery=" AND UPPER(company) LIKE UPPER('%"+qcompanyname+"%')";
			}
			if(qgamename!=null&&qgamename.length()!=0)
			{
				if(iscase)
					gamenameQuery=" AND name LIKE '%"+qgamename+"%'";
				else
					gamenameQuery=" AND UPPER(name) LIKE UPPER('%"+qgamename+"%')";
			}
			if(qgameid!=null&&qgameid.length()!=0)
				gameidQuery=" AND id="+qgameid;

			if(qgenre!=null&&qgenre.length()!=0)
				genreQuery=" AND genre LIKE '%"+qgenre+"%'";

			if(qprice!=null&&qprice.length()!=0&&qpriceob!=null&&qpriceob.length()!=0)
				priceQuery=" AND price"+qpriceob+qprice;
			if(qyear!=null&&qyear.length()!=0)
				yearQuery=" AND TO_CHAR(birth, 'YYYY') ="+qyear;

			String queryString="SELECT id, name, genre, TO_CHAR(birth, 'YYYY/MM/DD'), price, site, company FROM joec_game WHERE id = id"+companynameQuery+gamenameQuery+gameidQuery+genreQuery+priceQuery+yearQuery;

			out.println("<!--");
			out.println(queryString);
			out.println("-->");

			out.println("<HTML>");
			out.println("<HEAD>");
			out.println("<TITLE>");
			out.println("Game List");
			out.println("</TITLE>");
			out.println("<LINK REL=\"stylesheet\" TYPE=\"text/css\" HREF=\""+JoeEnv.styleDir+"/labstyle.css\" TITLE=\"Style\"");
			out.println("</HEAD>");
			out.println("<BODY background=\""+JoeEnv.imgDir+"/project/bg.gif\">");
			out.println("<CENTER><A HREF=\"ListGame\"><IMG SRC=\"");
			out.println(JoeEnv.imgDir+"/project/banner_gamelist.gif\" border=0></A></CENTER>");
			out.println("<P>");
			out.println("<TABLE BORDER=5>");

			out.println("<TH NOWRAP ALIGN=RIGHT>");
			out.println("Game Name");
			out.println("</TH>");

			out.println("<TH NOWRAP ALIGN=RIGHT>");
			out.println("Company Name");
			out.println("</TH>");

			out.println("<TH NOWRAP ALIGN=RIGHT>");
			out.println("Genre");
			out.println("</TH>");

			out.println("<TH NOWRAP ALIGN=RIGHT>");
			out.println("Price");
			out.println("</TH>");

			out.println("<TH NOWRAP ALIGN=RIGHT>");
			out.println("Birth Date");
			out.println("</TH>");

			out.println("<TH NOWRAP ALIGN=RIGHT>");
			out.println("Site");
			out.println("</TH>");

			Vector result=dbQuery.query(queryString);
			Iterator resultIterator=result.iterator();
			Vector resultEntryVector;
			while(resultIterator.hasNext())
			{
				resultEntryVector=(Vector)resultIterator.next();

				String gameid=(String)resultEntryVector.elementAt(0);
				String gamename=(String)resultEntryVector.elementAt(1);
				String genre=(String)resultEntryVector.elementAt(2);
				String birthdate=(String)resultEntryVector.elementAt(3);
				String price=(String)resultEntryVector.elementAt(4);
				String site=(String)resultEntryVector.elementAt(5);
				String companyname=(String)resultEntryVector.elementAt(6);

				out.println("<TR>");
				out.println("<TD NOWRAP ALIGN=RIGHT>");
				out.println("<A HREF=\"");
				out.println("ListGame?id="+gameid);
				out.println("\">");
				out.println(gamename);
				out.println("</TD>");

				out.println("<TD NOWRAP ALIGN=RIGHT>");
				out.println("<A HREF=\"");
				out.println("ListGame?company="+companyname);
				out.println("\">");
				out.println(companyname);
				out.println("</A>");
				out.println("</TD>");

				out.println("<TD NOWRAP ALIGN=RIGHT>");
				out.println("<A HREF=\"");
				out.println("ListGame?genre="+genre);
				out.println("\">");
				out.println(genre);
				out.println("</TD>");

				out.println("<TD NOWRAP ALIGN=RIGHT>");
				out.println(price+"$");
				out.println("</TD>");

				out.println("<TD NOWRAP ALIGN=RIGHT>");
				out.println(birthdate);
				out.println("</TD>");

				out.println("<TD NOWRAP ALIGN=RIGHT>");
				out.println("<A HREF=\"");
				out.println(site);
				out.println("\">");
				out.println(site);
				out.println("</TD>");

			}

			if(JoeEnv.admin.equals(CookieUser.getUser(request)))
			{
			}

			out.println("</TABLE>");

			if(result.size()==0)
			{
				out.println("<A HREF=\"");
				out.println("Dynamic?name="+qgamename);
				out.println("\">");
				out.println("Dynamic Search");
				out.println("</A>");
			}

			out.println("</BODY>");
			out.println("</HTML>");
			out.close();
		}
		catch(Exception e)
		{
		}
        }

	public void doPost(HttpServletRequest request,HttpServletResponse response) 
	{
		doGet(request,response);
	}
}
