
import java.net.*;
import java.util.*;
import java.io.*;

/**
* Tokenize class ̿ؼ URL ִ  token   parsing
* ؼ  tag text ̷ multiple tree .  optional
* tag  parsing Ϻ ʴ.  parsing normal tag Ȱ
* Ǿ ,   parsing ʿϴ.
*
* @author	Joon-Myung Kang
* @version	1.0
* @since	1999/5/22
*/

public class Tagtree {

	TableEndO optional = null; 
	TableEnd exist =  null;
	TableEndF forbidden =  null;

	Node root = null; 

	private	DataOutputStream	output;

	public Tagtree(URL source){
		optional = new TableEndO();
		exist = new TableEnd();
		forbidden = new TableEndF();

		
		Tokenize t = new Tokenize( source );

		Vector doc = new Vector();
		String ptr;
		while( ( ptr = t .getNext() )!= null ){
			if( ptr.charAt(0) != '<' ){
				ptr  = refine( ptr );
			}

			if( ptr != null ){ 
				doc.addElement( ptr );
				//System.out.println( ptr.length()+ ptr + "|||");
			}/*else{
				System.out.println( "|||||||||||||||||||||||"); 
			}*/
		}


		root = new Node( source.toString() );
		makeChild( root, doc );
	}

	public Node getRoot(){ return root; }

	Node makeSubtreePaired(Vector subtree){
	//input: pairs <tag...> ..........</tag>

		String str = new String( (String)subtree.elementAt(0));
		String str1 = new String( (String) subtree.elementAt(subtree.size()-1));
		//Node r = new Node( str+str1 ) ;
		Node r = new Node( getKey(str) );
		r.addChild(makeAttributeTree(str));		// added by mals

		//delete root entry
		subtree.removeElementAt( subtree.size() -1 );
		subtree.removeElementAt( 0 );

		makeChild( r , subtree );

		return r;
	}

	void makeChild( Node r, Vector subtree){	

		int i = 0;
		Node	childNode;

		while( i < subtree.size() ){


			if( isTag( (String)subtree.elementAt(i) ) ){ //tag 

				String key = 
					getKey((String)subtree.elementAt(i)).toUpperCase(); 

				if( optional.isExist( key )  ){
				//end tag ɼ tag 

					int	level = 0;	// added by mals
					int j = i+1;
					for( j = i+1; j < subtree.size() ; j++ )
					{
						if
							( 
								isTag( (String)subtree.elementAt(j) ) &&
								!isEndTag( (String)subtree.elementAt(j) ) &&
								getKey( (String)subtree.elementAt(j)).equals( 
									getKey( (String)subtree.elementAt(i) ) )
							)
						{
							level++;
						}
						else if
							(
								isTag( (String)subtree.elementAt(j) ) &&
								isEndTag( (String)subtree.elementAt(j) ) &&
								getKey( (String)subtree.elementAt(j)).equals( 
									getKey( (String)subtree.elementAt(i) )) 
							)
						{
							if(level == 0) 
						 	{
								Vector v = new Vector();
								for( int k = i ; k <= j ; k ++ )
									v.addElement( (String)subtree.elementAt(k) );
								r.addChild( makeSubtreePaired( v ) );
								//System.out.println("EXIST: "+subtree.elementAt(i));
								i = j +1;
								break;
							}
							else
							{
								level--;
							}
						}
					}
					if( j >= subtree.size() ){
						//r.addChild( new Node( (String)subtree.elementAt(i) ) );
						r.addChild( new Node( getKey( 
												(String)subtree.elementAt(i) 
											   ) ) );
						i += 1;
					} 
					//System.out.println("OPTIONAL: "+key);
				} else if( exist.isExist( key )){ 
				//end tag ݵ ; ϴ ±̸ 

					int	level = 0;	// added by mals
					int j = i+1;
					for( j = i+1; j < subtree.size() ; j++ ){

						if
							( 
								isTag( (String)subtree.elementAt(j) ) &&
								!isEndTag( (String)subtree.elementAt(j) ) &&
								getKey( (String)subtree.elementAt(j)).equals( 
									getKey( (String)subtree.elementAt(i) ) )
							)
						{
							level++;
						}
						else if
							(
								isTag( (String)subtree.elementAt(j) ) &&
								isEndTag( (String)subtree.elementAt(j) ) &&
								getKey( (String)subtree.elementAt(j)).equals( 
									getKey( (String)subtree.elementAt(i) )) 
							)
						{
							if(level == 0) 
						 	{
								Vector v = new Vector();
								for( int k = i ; k <= j ; k ++ )
									v.addElement( (String)subtree.elementAt(k) );
								r.addChild( makeSubtreePaired( v ) );
								//System.out.println("EXIST: "+subtree.elementAt(i));
								i = j +1;
								break;
							}
							else
							{
								level--;
							}
						}
					}
					if( j >= subtree.size() ){
						//r.addChild( new Node( (String)subtree.elementAt(i) ) );
						r.addChild( new Node( getKey(
												(String)subtree.elementAt(i) 
												)) );
						System.out.println("ERROR::paired tag: "+ subtree.elementAt(i));
						i += 1;
					} 

				} else if( forbidden.isExist( key) ){ 
				//end tag  ϴ tag 

					//System.out.println("forbidden: "+key);
				//	r.addChild( new Node( (String)subtree.elementAt(i) ) );
					childNode = new Node(getKey((String)subtree.elementAt(i)));
					/*
					r.addChild( new Node( getKey(
												(String)subtree.elementAt(i) 
												)) );
					*/
					childNode.addChild(makeAttributeTree((String)subtree.elementAt(i)));
					r.addChild(childNode);
					i += 1;
				} else{ 
					System.out.println("impossible tag: "+key);
					i += 1;
				}
			} else{ //text 
				r.addChild( new Node( (String)subtree.elementAt(i) ) );
				//System.out.println("TEXT: "+(String)subtree.elementAt(i) );
				i +=1;
			}
		}//endOfwhile
	}

	boolean isEndTag( String s){
		String ss = new String( refine( s.substring(1) ) );
		if( ss.charAt(0) == '/' ) return true;
		else return false;
	}

	String getKey( String s ){ //s is <tag.........>
		String ss = new String( refine( s.substring(1) ) );
		StringBuffer b = new StringBuffer();

		for( int i=0 ; i < ss.length(); i++){
			if( ss.charAt(i) == ' ' ) break;
			else if( ss.charAt(i) == '>' ) break;
			else if( ss.charAt(i) == '/'){}
			else
				b.append( ss.substring( i, i+1 ) );
		}
		return b.toString().toUpperCase();
	}

	boolean isTag( String s ){
		if( s.charAt(0) == '<' ) return true;
		else return false;
	}

	

	String refine( String s ){
	// s   ڵ ܽŲ. ó ̽  
	// ̽

		StringBuffer buffer = new StringBuffer();

		int init = 0; 
		int end = s.length() - 1;
		boolean t = true;
		int i = init;
		int j = end ;
		while( 	i < end ){
			if( s.charAt(i) == '\t'){
			}
			else if( s.charAt(i) == '\n' ){
			}
			else if( s.charAt(i) == ' ' ){
			}
			else{
				break;
			}

			i++;
		}

		while( 	j >= init ){
			if( s.charAt(j) == '	'){
			}
			else if( s.charAt(j) == '\n' ){
			}
			else if( s.charAt(j) == ' ' ){
			}
			else{
				break;
			}
			j--;
		}

		if( j < init  || i >= end ) return null;
		else return s.substring(i, j+1 ); 
	}

	public	void	makeTreeFile()
	// for testing program
	// make whole tree structure to "tree.txt" file
	{
		try
		{
			output = new DataOutputStream( new FileOutputStream("tree.txt"));
		}
		catch(IOException e)
		{
			System.err.println("Can't create Data file\n");
			System.exit(1);
		}
		root.makeTreeFile(output,0);
		try
		{
			output.close();
		}
		catch(IOException io)
		{
			System.err.println("Can't close Data file\n");
		}
	}

///////////////////////////////////////////////////////////////////////////
//	public	Node makeAttributeTree(String str)
//	  - str : input tag
//		ex> <table border=0 cellspacing=0 cellpadding=0>
//	this method ignore "nowrap"
// 	if there is no attribute, it returns "no_attribute" Node
///////////////////////////////////////////////////////////////////////////
	public	Node	makeAttributeTree(String str)
	{

		Node	attributeRootNode;	

		//System.out.println(str);

		if(str.indexOf("=") == -1)
		// when string has no attribute 
		{
			attributeRootNode = new Node("no_attribute");
		}
		else
		// when string has attributes
		{
			int	indexOfEqual = 0;	// index of "="
			int firstIndexOfLeftString = 0 ; 	// starting index of left side string of "="
			int lastIndexOfLeftString = 0 ; 	// endind	index of left side string of "="
			int firstIndexOfRightString = 0 ; 	// starting index of right side string of "="
			int lastIndexOfRightString = 0 ; 	// ending	index of right side string of "="
			//	ex>		color = white
			//          	index of 'c' is firstIndexOfLeftString
			//			index of 'r' is lastIndexOfLeftString
			//			index of 'w' is firstIndexOfRightString
			//			index of 'e' is lastIndexOfRightString

			attributeRootNode = new Node("attribute");
			Node	attributeNode;		// attributeNode will be attached to attributeRootNode	
			Node	attributeValueNode;	// attributeValueNode will be attached to attributeNode

			while( (indexOfEqual = str.indexOf("=",indexOfEqual)) != -1)
			// looping while there exists "="
			{
				//find left side string of "="(attribute)
				lastIndexOfLeftString = indexOfEqual-1;
				while(Character.isWhitespace(str.charAt(lastIndexOfLeftString)))
					lastIndexOfLeftString--;
				firstIndexOfLeftString = lastIndexOfLeftString;
				while(Character.isJavaLetterOrDigit(str.charAt(firstIndexOfLeftString)))
					firstIndexOfLeftString--;
				firstIndexOfLeftString++;

				//find right side string of "="(attribute value)
				firstIndexOfRightString = indexOfEqual+1;
				while(Character.isWhitespace(str.charAt(firstIndexOfRightString)))
					firstIndexOfRightString++;
				if(str.charAt(firstIndexOfRightString)=='\"')
				// staring with "\""
				{
					firstIndexOfRightString++;
					lastIndexOfRightString = str.indexOf('\"',firstIndexOfRightString);
					lastIndexOfRightString--;
				}
				else
				{
					lastIndexOfRightString = firstIndexOfRightString;
					while((!Character.isWhitespace(str.charAt(lastIndexOfRightString)))&&
						  (str.charAt(lastIndexOfRightString)!='>'))
						lastIndexOfRightString++;
					lastIndexOfRightString--;
				}
				/*
				System.out.println("indexOfEqual : "+Integer.toString(indexOfEqual));
				System.out.println("firstIndexOfLeftString : "+Integer.toString(firstIndexOfLeftString));
				System.out.println("lastIndexOfLeftString : "+Integer.toString(lastIndexOfLeftString));
				System.out.println("firstIndexOfRightString : "+Integer.toString(firstIndexOfRightString));
				System.out.println("lastIndexOfRightString : "+Integer.toString(lastIndexOfRightString));
				*/
				attributeNode = new Node(str.substring(firstIndexOfLeftString,lastIndexOfLeftString+1));
				attributeValueNode = new Node(str.substring(firstIndexOfRightString,lastIndexOfRightString+1));
				attributeNode.addChild(attributeValueNode);
				attributeRootNode.addChild(attributeNode);
				indexOfEqual=lastIndexOfRightString+1;
			}
		}

		return attributeRootNode;
	}

	void MTreeToLT( MTree t ){
	}
}
