package jess.examples.pumps;
import jess.*;

/**
  An example of creating Beans in Java, then telling Jess about them.

  Don't run this from this directory! It expects you to run it from the
  JessXX distribution directory, like this:

    java jess.examples.pumps.MainInJava

  */

public class MainInJava
{
  public static void main(String[] argv) throws ReteException
  {
    Rete rete = new Rete(new NullDisplay());
    rete.addUserpackage(new MiscFunctions());
    rete.addUserpackage(new jess.reflect.ReflectFunctions());

    // Read in the rules
    rete.executeCommand("(batch jess/examples/pumps/pumps-fromjava.clp)");
    rete.executeCommand("(reset)");

    // Create the Beans
    Tank t = new Tank("MAIN");
    Pump p = new Pump("MAIN", t);
    
    // Tell Jess about them
    Funcall f = new Funcall("definstance", rete);               
    f.add(new Value("pump", RU.ATOM));
    f.add(new Value(p, RU.EXTERNAL_ADDRESS));
    f.simpleExecute(f, rete.globalContext());
    
    f = new Funcall("definstance", rete);               
    f.add(new Value("tank", RU.ATOM));
    f.add(new Value(t, RU.EXTERNAL_ADDRESS));
    f.simpleExecute(f, rete.globalContext());
    
    rete.executeCommand("(run)");
  }

}
